SystemOrganization addCategory: #'GT-Examples-UI'!

!GTExampleSelectorSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 12:44'!
addToSelectorEnvironment: aSelectorEnvironment
	self selector ifNil: [ ^ self ].
	
	self theClasses do: [ :class | 
		aSelectorEnvironment addClass: class selector: self selector ]! !

!GTExampleSelectorSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:52'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock 
		value: #'Browse selector-subject "' ,  self selector , '"'
		value: [ 
			| env |
			self addToSelectorEnvironment: (env := RBSelectorEnvironment new).
			env browse ]! !

!GTExampleSelectorSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 12:43'!
gtDisplayOn: aStream
	self selector gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

!GTExampleUnexpectedExceptionRaised methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 4/10/2016 11:14'!
gtDisplayOn: aStream
	super gtDisplayOn: aStream.
	aStream nextPutAll: ' ('.
	self unexpectedError gtDisplayOn: aStream.
	aStream nextPutAll: ')'.! !

!MorphicUIManager methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 16:47'!
gtInform: aStringOrText send: aSelector to: anObject withValue: anArgument
	"Display a message for the user to read and then dismiss."
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [ :answer | ^ self ].
	(GrowlMorph 
		openWithLabel: 'Information' translated 
		contents: aStringOrText)
			on: #mouseDown send: aSelector to: anObject withValue: anArgument.! !

!GTExampleTagSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 16:07'!
addToSelectorEnvironment: aSelectorEnvironment
	self thePackage ifNil: [ ^ self ].
	
	self thePackage classes do: [ :class | 
		aSelectorEnvironment addClass: class ]! !

!GTExampleTagSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:52'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock 
		value: #'Browse tag-subject "' ,  self theTagName , '"'
		value: [ self theTag browse ]! !

!GTExampleTagSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:10'!
gtDisplayOn: aStream
	self theTagName gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

Object subclass: #GTAbstractExampleMenu
	instanceVariableNames: 'lastItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:29'!
menuFor: aBuilder
	self subclassResponsibility ! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:03'!
browseAllExamples: aBuilder
	(lastItem := aBuilder item: 'Browse all examples')
		parent: #gte;
		keyText: 'e, a' if: Nautilus useOldStyleKeys not;
		action: [ GTExampleNavigation browseExamples ];
		icon: Smalltalk ui icons nautilus
! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:03'!
browseAllExamplesIgnoredByTests: aBuilder		
	(lastItem := aBuilder item: 'Browse all examples ignored by tests')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesIgnoredByTests ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:03'!
browseAllExamplesWithDependencies: aBuilder
	(lastItem := aBuilder item: 'Browse all examples with dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithDependencies ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:04'!
browseAllExamplesWithProblems: aBuilder		
	(lastItem := aBuilder item: 'Browse all examples with problems')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithProblems ];
		icon: Smalltalk ui icons smallError.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
browseExamplesReferencing: aLiteral builder: aBuilder	
	(lastItem := aBuilder item: 'Browse examples referencing "' ,  aLiteral , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesReferencing: aLiteral ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 16:56'!
browseExamplesWithSubject: aLiteral builder: aBuilder
	" this is yet too complicated - SIMPLIFY term and behavior for the user
	
	(lastItem := aBuilder item: 'Browse examples with subject ""' ,  aLiteral gtDisplayString , '""')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithSubject: aLiteral ]
	"! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
buildAllDependencies: aCollection builder: aBuilder with: aBlock
	^ (aBuilder item: #'Browse all dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependenciesOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
buildAllDependents: aCollection builder: aBuilder
	^ (aBuilder item: #'Browse all dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependentsOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
buildDependencies: aCollection builder: aBuilder 
	^ (aBuilder item: #'Browse dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseDependenciesOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
buildDependents: aCollection builder: aBuilder
	^ (aBuilder item: #'Browse dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseDependentsOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:57'!
buildSeparator
	lastItem ifNil: [ ^ self ].
	lastItem withSeparatorAfter! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:25'!
buildSubmenu: aBuilder
	(lastItem := aBuilder item: #gte)
		order: self submenuOrder;
		label: 'GT Examples';
		withSeparatorAfter.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:25'!
debugExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Debug examples')
		parent: #gte;
		keyText: 'e, d' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :each | each debug ] ];
		icon: Smalltalk ui icons smallDebug.! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock
	self examples: aBlock select: [ :each | true ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:03'!
examples: aBlock1 collect: aBlock2
	self examples: aBlock1 select: [ :each | true ] collect: [ :each | aBlock2 value: each ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/22/2016 11:34'!
examples: aCollection do: aBlock1 progress: aBlock2
	| progress |
	aCollection size < 2 ifTrue: [ ^ aCollection do: aBlock1 ].
	aBlock2 ifNil: [ ^ aCollection do: aBlock1 ].
	(progress := aBlock2 value: aCollection) isEmptyOrNil ifTrue: [ ^ aCollection do: aBlock1 ].
	aCollection do: aBlock1 displayingProgress: progress! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock1 select: aBlock2
	(aBlock1 value select: [ :example | 
		example isGTExample 
			and: [ aBlock2 value: example ] ])
				ifNotEmpty: [ :examples | 
					(examples size = 1 
						ifTrue: [ examples anyOne ]
						ifFalse: [ examples ]) inspect ]
				ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock1 select: aBlock2 collect: aBlock3
	| examples |
	examples := Dictionary new.
	aBlock1 value 
		select: [ :each | each isGTExample and: [ aBlock2 value: each ] ] 
		thenDo: [ :each | examples at: each put: (aBlock3 value: each) ].
	examples
		ifNotEmpty: [ examples inspect ]
		ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 8/28/2016 14:48'!
examples: aBlock1 select: aBlock2 collect: aBlock3 progress: aBlock4
	| results |
	results := Dictionary new.
	self examples: (aBlock1 value select: [ :each | each isGTExample and: [ aBlock2 value: each ] ]) 
		do: [ :each | results at: each put: (aBlock3 value: each) ]
		progress: aBlock4.
	results
		ifNotEmpty: [ 
			(results size = 1
				ifTrue: [ results anyOne ]
				ifFalse: [ results ]) inspect ]
		ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/22/2016 11:33'!
examples: aBlock1 withProgressCollect: aBlock2
	self examples: aBlock1 
		select: [ :each | true ] 
		collect: [ :each | aBlock2 value: each ] 
		progress: [ :examples | 'Processing ' , examples size asString , ' examples ...' ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:26'!
inspectExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect examples')
		parent: #gte;
		keyText: 'e, i' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock ];
		icon: Smalltalk ui icons glamorousInspect.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:26'!
inspectProblems: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect problems')
		parent: #gte;
		action: [ self examples: aBlock select: [ :each | each hasProblems ] collect: [ :each | each problems ] ];
		icon: Smalltalk ui icons smallError! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:26'!
inspectResults: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect results (full)')
		parent: #gte;
		action: [ self examples: aBlock withProgressCollect: [ :example | example result ] ].! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:26'!
inspectReturnValue: aBlock builder: aBuilder
	(lastItem := aBuilder item: #'Inspect return-values')
		parent: #gte;
		keyText: 'e, v' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :example | example returnValue ] ].! !

!GTAbstractExampleMenu methodsFor: 'public' stamp: 'StefanReichhart 7/14/2016 17:27'!
menuFor: aBuilder! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 12:51'!
notifyNoExamples
	GrowlMorph 
		openWithLabel: 'GT Examples'
		contents: 'No examples found within the current selection' ! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:26'!
runExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Run examples')
		parent: #gte;
		keyText: 'e, r' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :each | each run ] ];
		icon: Smalltalk ui icons smallDoIt.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:35'!
submenuOrder
	^ -9999! !

GTAbstractExampleMenu subclass: #GTExampleNautilusClassMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusClassMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:28'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalClassMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:24'!
browseClass: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse examples of class "' ,  aClass name , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:24'!
browseHierarchyOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse examples in hierarchy of class "' , aClass name , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInHierarchyOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 16:20'!
browseSubclassesOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse examples in subclasses of class "' , aClass name , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInSubclassesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browseSuperclassesOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse examples in superclasses of class "' , aClass name , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInSuperclassesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:02'!
menuFor: aBuilder
	| model class |
	(model := aBuilder model) ifNil: [ ^ self ].
	(class := model selectedClass) ifNil: [ ^ self ].
	
	self buildSubmenu: aBuilder.
	self inspectExamples: [ class gtExamples ] builder: aBuilder.
	self inspectReturnValue: [ class gtExamples ] builder: aBuilder.
	self inspectResults: [ class gtExamples ] builder: aBuilder.
	self inspectProblems: [ class gtExamples ] builder: aBuilder.
	self buildSeparator.
	self runExamples: [ class gtExamples ] builder: aBuilder.
	self debugExamples: [ class gtExamples ] builder: aBuilder.
	self buildSeparator.
	self browseClass: class builder: aBuilder.
	self browseSubclassesOf: class builder: aBuilder.
	self browseSuperclassesOf: class builder: aBuilder.
	self browseHierarchyOf: class builder: aBuilder.
	self buildSeparator.
	self browseExamplesReferencing: class theNonMetaClass name builder: aBuilder.
	self browseExamplesWithSubject: class asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:38'!
submenuOrder
	^ 1300! !

GTAbstractExampleMenu subclass: #GTExampleNautilusMethodMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusMethodMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:28'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalMethodMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:04'!
browseAfter: aCollection builder: aBuilder
	aCollection do: [ :after | 
		after forNautilus: [ :title :action | 
			(lastItem := aBuilder item: title)
				parent: #gte;
				action: [ action value ] ] ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browseAllDependencies: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse all dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependenciesOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browseAllDependents: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse all dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependentsOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browseDependencies: aCollection builder: aBuilder 
	(lastItem := aBuilder item: #'Browse dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseDependenciesOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browseDependents: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseDependentsOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 16:53'!
browseExampleSubjects: aCollection builder: aBuilder
	" this is yet too complicated - SIMPLIFY term and behavior for the user
	
	(lastItem := aBuilder item: #'Browse subjects')
		parent: #gte;
		action: [ GTExampleNavigation browseAllExampleSubjects: aCollection ];
		icon: Smalltalk ui icons glamorousDiveRight
	"! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 16:57'!
browseSubjects: aCollection builder: aBuilder
	" this is yet too complicated - SIMPLIFY term and behavior for the user
	
	aCollection do: [ :subject | 
		subject forNautilus: [ :title :action | 			
			(lastItem := aBuilder item: title)
				parent: #gte;
				action: [ action value ] ] ]
	"! !

!GTExampleNautilusMethodMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:02'!
menuFor: aBuilder
	| model method examples |
	(model := aBuilder model) ifNil: [ ^ self ].
	(method := model selectedMethod) ifNil: [ ^ self ].
	examples := method gtExamples reject: [ :each | each isNil ].
	
	self buildSubmenu: aBuilder.
	examples ifNotEmpty: [ 
		| problems arguments subjects afters |
		problems := (examples gather: [ :each | each problems ]) reject: [ :each | each isNil ].
		arguments := (examples gather: [ :each | each arguments ]) reject: [ :each | each isNil ].
		afters := (examples collect: [ :each | each after ]) reject: [ :each | each isNil ].
		subjects := (examples gather: [ :each | each subjects ]) reject: [ :each | each isNil ].
		self inspectExamples: [ examples ] builder: aBuilder.
		self inspectReturnValue: [ examples ] builder: aBuilder.
		self inspectResults: [ examples ] builder: aBuilder.
		problems ifNotEmpty: [
			self inspectProblems: [ examples ] builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		self runExamples: [ examples ] builder: aBuilder.
		self debugExamples: [ examples ] builder: aBuilder.
		self buildSeparator.
		arguments ifNotEmpty: [
			self browseDependencies: examples builder: aBuilder.
			self browseDependents: examples builder: aBuilder.
			self buildSeparator.
			self browseAllDependencies: examples builder: aBuilder.
			self browseAllDependents: examples builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		afters ifNotEmpty: [ 
			self browseAfter: afters builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		subjects ifNotEmpty: [ 
			self browseExampleSubjects: examples builder: aBuilder.
			self browseSubjects: subjects builder: aBuilder.
			self buildSeparator ].
		self buildSeparator ].
	self browseExamplesReferencing: method selector builder: aBuilder.
	self browseExamplesWithSubject: method asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:33'!
submenuOrder
	^ 1450! !

GTAbstractExampleMenu subclass: #GTExampleNautilusPackageMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusPackageMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:29'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalPackageMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusPackageMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:23'!
browsePackage: aPackage builder: aBuilder
	(lastItem := aBuilder item: #'Browse all examples of package "' ,  aPackage packageName , '"')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesOfPackage: aPackage ]! !

!GTExampleNautilusPackageMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:01'!
menuFor: aBuilder
	| model node package |
	(model := aBuilder model) ifNil: [ ^ self ].
	(node := model selectedPackage) ifNil: [ ^ self ].
	(package := node item) ifNil: [ ^ self ].
	
	self buildSubmenu: aBuilder.
	self inspectExamples: [ package gtExamplesContained ] builder: aBuilder.
	self inspectReturnValue: [ package gtExamplesContained ] builder: aBuilder.
	self inspectResults: [ package gtExamplesContained ] builder: aBuilder.
	self inspectProblems: [ package gtExamplesContained ] builder: aBuilder.
	self buildSeparator.
	self runExamples: [ package gtExamplesContained ] builder: aBuilder.
	self debugExamples: [ package gtExamplesContained ] builder: aBuilder.
	self buildSeparator.
	self browsePackage: package builder: aBuilder.
	self buildSeparator.
	self browseExamplesReferencing: package packageName  builder: aBuilder.
	self browseExamplesWithSubject: package asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusPackageMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:35'!
submenuOrder
	^ 1010! !

GTAbstractExampleMenu subclass: #GTExamplePlaygroundMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExamplePlaygroundMenu class methodsFor: 'menus' stamp: 'StefanReichhart 8/28/2016 16:35'!
menuFor: aPlayground
	^ self new
		menuFor: aPlayground
		yourself! !

!GTExamplePlaygroundMenu methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 8/28/2016 16:55'!
menuFor: aPlayground
	^ {
		" this is yet too complicated - SIMPLIFY term and behavior for the user 
		
		(GLMGenericAction new) 
			title: 'Browse examples with subject ...';
			action: [ :aPresentation | GTExampleNavigation browseExamplesWithSubjectMatching:  aPresentation selectedText asString ]; 
			category: 'GT Examples';
			yourself.
		"
		(GLMGenericAction new) 
			title: 'Browse examples with literal ...';
			action: [ :aPresentation | GTExampleNavigation browseExamplesLiteralThorough: aPresentation selectedText asString ]; 
			category: 'GT Examples';
			yourself.
	}! !

GTAbstractExampleMenu subclass: #GTExampleRubEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleRubEditor class methodsFor: 'menus' stamp: 'StefanReichhart 8/6/2016 21:28'!
menuFor: aBuilder
	<contextMenu>
	<RubSmalltalkCodeMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleRubEditor methodsFor: 'public' stamp: 'StefanReichhart 8/28/2016 16:55'!
menuFor: aBuilder
	| selection selectedText selectedString |
	aBuilder model ifNil: [ ^ self ].
	aBuilder model model ifNil: [ ^ self ].
	(selection := aBuilder model selectionInterval) isEmptyOrNil ifTrue: [ ^ self ].
	(selectedText := aBuilder model gtGetText copyFrom: selection first to: selection last) isEmptyOrNil ifTrue: [ ^ self ].
	(selectedString := selectedText asString) isEmptyOrNil ifTrue: [ ^ self ].
	
	(lastItem := aBuilder item: 'GT Examples')
		withSeparatorAfter;
		with: [ 
			" this is yet too complicated - SIMPLIFY term and behavior for the user
			
			(lastItem := aBuilder item: #'Browse examples with subject ""' , selectedString , '""')
				action: [ GTExampleNavigation browseExamplesWithSubjectMatching: selectedString ].
			"
			(lastItem := aBuilder item: #'Browse examples with literal "' , selectedString, '"')
				action: [ GTExampleNavigation browseExamplesLiteralThorough: selectedString ]. ]! !

GTAbstractExampleMenu subclass: #GTExampleWorldMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleWorldMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/15/2016 13:19'!
menuFor: aBuilder
	<worldMenu>
	^ self new 
		menuFor: aBuilder;
		yourself! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:49'!
buildSubmenu: aBuilder
	(lastItem := aBuilder item: #gte)
		order: 0.15;
		parent: 'Tools';
		label: 'GT Examples';
		withSeparatorAfter.! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:05'!
disableNotifications: aBuilder
	(lastItem := aBuilder item: 'Disable notifications')
		parent: #gte;
		action: [ GTExampleNautilusNotifications stop ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:05'!
enableNotifications: aBuilder
	(lastItem := aBuilder item: 'Enable notifications')
		parent: #gte;
		action: [ GTExampleNautilusNotifications start ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:05'!
inspectAllExamples: aBuilder
	(lastItem := aBuilder item: 'Inspect all examples')
		parent: #gte;
		action: [ self examples: [ Smalltalk gtExamplesContained ] ];
		icon: Smalltalk ui icons glamorousInspect.! !

!GTExampleWorldMenu methodsFor: 'public' stamp: 'StefanReichhart 7/21/2016 18:00'!
menuFor: aBuilder
	self buildSubmenu: aBuilder.
	
	self inspectAllExamples: aBuilder.
	
	self buildSeparator.
	
	self browseAllExamples: aBuilder.
	self browseAllExamplesWithProblems: aBuilder.
	self browseAllExamplesWithDependencies: aBuilder.
	self browseAllExamplesIgnoredByTests: aBuilder.
	
	self buildSeparator.
	
	self toggleNotifications: aBuilder.
	
	self buildSeparator.
	
	self resetAllExamples: aBuilder! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:05'!
resetAllExamples
	GTExampleOrganizer reset.
	GTExampleOrganizer restart.
	Smalltalk garbageCollect; garbageCollectMost.! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 8/28/2016 15:05'!
resetAllExamples: aBuilder
	(lastItem := aBuilder item: 'Reset all examples')
		parent: #gte;
		action: [ self resetAllExamples ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 18:02'!
toggleNotifications: aBuilder
	GTExampleNautilusNotifications isEnabled
		ifTrue: [ self disableNotifications: aBuilder ]
		ifFalse: [ self enableNotifications: aBuilder ]! !

Object subclass: #GTExampleNautilusNotifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

GTExampleNautilusNotifications class
	instanceVariableNames: 'notifying'!

GTExampleNautilusNotifications class
	instanceVariableNames: 'notifying'!

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 14:57'!
changed: anAnnouncement
	| examples |
	examples := Smalltalk gtExamplesContained select: [ :example | example hasProblems ].
	examples size > 4 ifTrue: [ ^ self notifyExamples: examples ].
	examples do: [ :example | self notifyExample: example ]! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:58'!
example: aGTExample event: anEvent from: anEventSource
	GTExampleNavigation browse: 'Examples with Problems' examples: { aGTExample }! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:58'!
examples: aCollection event: anEvent from: anEventSource
	GTExampleNavigation browse: 'Examples with Problems' examples: aCollection! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/21/2016 18:02'!
isEnabled
	^ notifying == true! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:19'!
notifyExample: aGTExample
	UIManager default 
		gtInform: 'Example ', aGTExample gtDisplayString , ' is invalid' , String cr, ' (click to browse)'
		send: #example:event:from:
		to: self
		withValue: aGTExample! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:19'!
notifyExamples: aCollection
	UIManager default 
		gtInform: 'There are ' , aCollection size asString , ' invalid examples' , String cr, ' (click to browse)'
		send: #examples:event:from:
		to: self
		withValue: aCollection! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 15:00'!
registerInterestToSystemAnnouncement
	<systemEventRegistration>
	
	self restart! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/5/2016 11:52'!
restart
	" self restart "
	self stop.
	self start.! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/12/2016 10:59'!
start
	" self start "
	notifying == true ifTrue: [ ^ self ].
	SystemAnnouncer uniqueInstance weak 
		when: GTExamplesModifiedAnnouncement send: #changed: to: self.
	notifying := true! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/5/2016 15:01'!
stop
	" self stop "
	SystemAnnouncer uniqueInstance unsubscribeThoroughly: self.
	Announcer allSubInstances do: [ :each | each unsubscribeThoroughly: self ].
	notifying := false! !

Object subclass: #GTExampleNavigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:56'!
browse: aString examples: aCollection
	| env |
	env := RBSelectorEnvironment new.
	aCollection do: [ :example |
		env addClass: example methodClass selector: example selector ].
	env isEmpty 
		ifTrue: [ ^ UIManager default inform: 'No examples found' ].
	^ env gtBrowseFor: aString! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:14'!
browseAllDependenciesOf: aCollectionOfExamples
	self browse: 'Dependencies' examples: (aCollectionOfExamples gather: [ :each | each allDependencies ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseAllDependentsOf: aCollectionOfExamples
	self browse: 'All dependents' examples: (aCollectionOfExamples gather: [ :each | each allDependents ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseAllExampleAfterMethods: aCollectionOfExamples
	" self browseAllExampleAfterMethods: GTExample "
	| env |
	env := RBSelectorEnvironment new.
	aCollectionOfExamples do: [ :example | 
		example after ifNotNil: [
			example after addToSelectorEnvironment: env ] ].
	^ env gtBrowseFor: 'After-methods'! !

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:55'!
browseAllExampleSubjects: aCollectionOfExamples
	" self browseAllExamplesWithSubject: GTExample "
	| env |
	env := RBSelectorEnvironment new.
	aCollectionOfExamples do: [ :example | 
		example subjects do: [ :subject | 
			subject ifNotNil: [ 
				subject addToSelectorEnvironment: env ] ] ].
	^ env gtBrowseFor: 'Subjects'! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:08'!
browseDependenciesOf: aCollectionOfExamples
	self browse: 'Dependencies' examples: (aCollectionOfExamples gather: [ :each | each dependencies ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:16'!
browseDependentsOf: aCollectionOfExamples
	self browse: 'Dependents' examples: (aCollectionOfExamples gather: [ :each | each directDependents ])! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamples
	" self browseAllExamples "
	self browseExamples: 'Examples' select: [ :example | true ]! !

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:56'!
browseExamples: aString select: aBlock
	^ self browse: aString examples: (Smalltalk gtExamplesContained select: [ :example | aBlock value: example ])! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseExamplesIgnoredByTests
	" self browseAllExamplesIgnoredByTests "
	self browseExamples: 'Examples ignored by tests' select: [ :example | 
		example ignoreTest 
			or: [ example ignoreTestReport ] ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseExamplesInHierarchyOfClass: aClass
	self browse: 'Examples in hierarchy of class "' , aClass name , '"' examples: (aClass withAllSubclasses gather: [ :each | each gtExamples ]), (aClass allSuperclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:20'!
browseExamplesInSubclassesOfClass: aClass
	self browse: 'Examples in subclasses of class "' , aClass name , '"' examples: (aClass withAllSubclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:20'!
browseExamplesInSuperclassesOfClass: aClass
	self browse: 'Examples in superclasses of class "' , aClass name , '"' examples: (aClass withAllSuperclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:20'!
browseExamplesLiteralThorough: aString
	" self browseExamplesLiteralThorough: #and: "
	self browseExamples: 'Examples with literal "', aString, '"' select: [ :example | 
		example hasLiteralThorough: aString ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:20'!
browseExamplesOfClass: aClass
	self browse: 'Examples of class "' , aClass name, '"' examples: aClass gtExamples! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:20'!
browseExamplesOfPackage: anRPackage
	self browse: 'Examples of package "' , anRPackage packageName, '"' examples: anRPackage gtExamplesContained! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:21'!
browseExamplesReferencing: aLiteral
	" self browseAllExamplesReferencing: #and: "
	self browseExamples: 'Examples referencing "', aLiteral asString, '"' select: [ :example | 
		example isReferencing: aLiteral ]! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseExamplesWithDependencies
	" self browseAllExamplesWithDependencies "
	self browseExamples: 'Examples with dependencies' select: [ :example | 
		example hasArguments ]! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 8/28/2016 15:19'!
browseExamplesWithProblems
	" self browseExamplesWithProblems "
	self browseExamples: 'Examples with problems' select: [ :example | 
		example hasProblems ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:21'!
browseExamplesWithSubject: aGTExampleSubject
	" self browseAllExamplesWithSubject: GTExample "
	self browseExamples: 'Examples with subject "', aGTExampleSubject gtDisplayString, '"' select: [ :example | 
		example hasSubject: aGTExampleSubject ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/28/2016 15:21'!
browseExamplesWithSubjectMatching: aGTExampleSubject
	" self browseAllExamplesWithSubject: GTExample "
	self browseExamples: 'Examples with subject "', aGTExampleSubject gtDisplayString, '"' select: [ :example | 
		example hasSubjectMatching: aGTExampleSubject ]! !

Object subclass: #GTExampleWithResult
	instanceVariableNames: 'example result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleWithResult methodsFor: 'public' stamp: 'TudorGirba 7/24/2017 21:30'!
debug
	self result: self example debug! !

!GTExampleWithResult methodsFor: 'accessing' stamp: 'TudorGirba 7/24/2017 15:37'!
example
	^ example! !

!GTExampleWithResult methodsFor: 'accessing' stamp: 'TudorGirba 7/24/2017 15:37'!
example: anObject
	example := anObject! !

!GTExampleWithResult methodsFor: 'printing' stamp: 'TudorGirba 7/24/2017 15:47'!
gtDisplayOn: stream
	self example gtDisplayOn: stream! !

!GTExampleWithResult methodsFor: 'testing' stamp: 'TudorGirba 7/24/2017 15:38'!
hasResult
	^ result notNil! !

!GTExampleWithResult methodsFor: 'ui' stamp: 'TudorGirba 7/24/2017 15:45'!
icon
	self isSuccess ifTrue: [ ^ ThemeIcons current iconNamed: #testGreen ].
	(self isError or: [ self isFailure ]) ifTrue: [ ^ ThemeIcons current iconNamed: #testRed ].
	^ ThemeIcons current iconNamed: #testNotRun! !

!GTExampleWithResult methodsFor: 'testing' stamp: 'TudorGirba 7/24/2017 15:37'!
isError
	^ self hasResult and: [ self result isError ]! !

!GTExampleWithResult methodsFor: 'testing' stamp: 'TudorGirba 7/24/2017 15:38'!
isFailure
	^ self hasResult and: [ self result isFailure ]! !

!GTExampleWithResult methodsFor: 'testing' stamp: 'TudorGirba 7/24/2017 15:46'!
isSuccess
	^ self hasResult and: [ self result isSuccess ]! !

!GTExampleWithResult methodsFor: 'accessing' stamp: 'TudorGirba 7/24/2017 15:37'!
result
	^ result! !

!GTExampleWithResult methodsFor: 'accessing' stamp: 'TudorGirba 7/24/2017 15:37'!
result: anObject
	result := anObject! !

!GTExampleWithResult methodsFor: 'public' stamp: 'TudorGirba 7/24/2017 17:45'!
run
	^ self result: self example run! !

!Object methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 1/27/2016 00:18'!
gtExampleSourceIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 100>
	| previousRawSelection |
	"we first check to see if we have at least two panes, because only
	if we have two panes does it make sense to check the raw selection of the previous pane"
	((aGTInspector isKindOf: GTInspector) and: [aGTInspector first panes size >= 2]) ifFalse: [ ^ self ].
	
	previousRawSelection := (aGTInspector first panes reverse second port: #rawSelection) value.
	previousRawSelection isGTExample ifTrue: [ 
		previousRawSelection gtInspectorSourceIn: composite ]! !

!TGTExampleIcon methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/19/2016 14:50'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 0>
	self exists ifFalse: [ ^ self ].
	
	self form gtInspectorFormIn: composite! !

!GTExampleInstanceSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:53'!
forNautilus: aBlock
	aBlock
		value: #'Inspect instance-subject "' ,  self instance gtDisplayString , '"'
		value: [ self instance inspect ]! !

!GTExampleInstanceSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:10'!
gtDisplayOn: aStream
	self instance gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

!GTPlayground class methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 16:35'!
menuFor: aPlayground
	<playgroundContextMenu>
	^ GTExamplePlaygroundMenu menuFor: aPlayground! !

!MorphicTextAdapter methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 16:28'!
gtGetText
	^ self model text asString! !

!RubScrolledTextMorph methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 16:25'!
gtGetText
	^ self model text asString! !

!GTExamplePackageSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 16:09'!
addToSelectorEnvironment: aSelectorEnvironment
	self thePackage ifNil: [ ^ self ].
	
	self thePackage classes do: [ :class | 
		aSelectorEnvironment addClass: class ].
	self thePackage extensionMethods do: [ :method | 
		aSelectorEnvironment addClass: method methodClass selector: method selector ]! !

!GTExamplePackageSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:52'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock 
		value: #'Browse package-subject "' ,  self thePackageName , '"'
		value: [ self thePackage browse ]! !

!GTExamplePackageSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:10'!
gtDisplayOn: aStream
	self thePackageName gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

!SmalltalkImage methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 8/22/2016 03:19'!
gtInspectorExamplesContainedIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Examples';
		display: [ self gtExamplesContained ];
		column: 'Example' evaluated: [ :each | each gtDisplayString ];
		column: 'Subject' evaluated: [ :each | ', ' join: (each subjects collect: [:s | s gtDisplayString ]) ]! !

!SmalltalkImage methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 8/22/2016 03:27'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ self gtExamplesContained asSet ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:12'!
gtDisplayOn: aStream
	super gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

!GTExampleSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:58'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 102>
	aStep listProcessor
		title: 'Examples with Subject ', self gtDisplayString;
		filter: GTNullFilter item: [ :filter :context | 
			GTExampleOrganizer instance examplesDo: [ :cn :s :example |
				(example hasSubject: self) ifTrue: [ filter value: example ] ] ];
		wantsToDisplayOnEmptyQuery: true! !

!GTExampleOrganizer methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 8/21/2016 07:22'!
gtInspectorExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Examples';
		display: [ self gtExamplesContained ];
		format: [ :each | each gtDisplayString ]! !

!GTExampleOrganizer methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:58'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		filter: GTNullFilter item: [ :filter :context | 
			self examplesDo: [ :cn :s :example | filter value: example ] ]! !

!GTExampleHelpSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:53'!
forNautilus: aBlock
	aBlock 
		value: #'Browse help-subject "' ,  self topic gtDisplayString , (self title ifNotNil: [ ' > ', self title ] ifNil: [ '' ]) , '"'
		value: [ 
			| browser |
			browser := (HelpBrowser openOn: self topic).
			self title ifNotNil: [ browser selectTopicSatisfying: [ :subhelp | subhelp title = self title ] ] ]! !

!GTExampleHelpSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 15:56'!
gtDisplayOn: aStream
	self exists 
		ifTrue: [ self topic gtDisplayOn: aStream ]
		ifFalse: [ 
			self bookName gtDisplayOn: aStream.
			self title isEmptyOrNil ifFalse: [ 
				aStream nextPutAll: ' > '.
				self title gtDisplayOn: aStream ] ].
	self gtDisplayValidityOn: aStream! !

!GTExampleMethodSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:54'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock
		value: #'Browse method-subject "' ,  self method gtDisplayString , '"'
		value: [ self method browse ]! !

!GTExampleMethodSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 13:51'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 102>
	aStep listProcessor
		title: 'Examples with Subject ', self gtDisplayString;
		filter: GTNullFilter item: [ :filter :context | 
			GTExampleOrganizer instance examplesDo: [ :cn :s :example |
				(example hasSubject: self) ifTrue: [ filter value: example ] ] ];
		wantsToDisplayOnEmptyQuery: true! !

!GTExampleKeywordSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 12:19'!
gtDisplayOn: aStream
	self keyword gtDisplayOn: aStream! !

!GTExampleGroup methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 7/24/2017 21:40'!
gtInspectorExamplesIn: composite
	<gtInspectorPresentationOrder: 1>
	| examplesWithResults |
	examplesWithResults := self examples collect: [ :each | GTExampleWithResult new example: each ].
	composite fastTable
		title: 'Examples';
		display: [ examplesWithResults ];
		icon: [ :each | each icon ];
		column: 'Name' evaluated: [ :each | each gtDisplayString ];
		column: 'Selector' evaluated: [ :each | each example selector ];
		column: 'Class' evaluated: [ :each | each example methodClass instanceSide name ];
		selectionAct: [ :list | list rawSelection run . list update ] on: $r command entitled: 'Run';
		selectionAct: [ :list | list rawSelection debug . list update ] entitled: 'Debug';
		act: [ :list | list displayValue do: [:each | each run ] displayingProgress: 'Running examples ...'. list update ] on: $r command shift entitled: 'Run all'! !

!GTExampleIcon methodsFor: '*GT-Examples-UI' stamp: ''!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 0>
	self exists ifFalse: [ ^ self ].
	
	self form gtInspectorFormIn: composite! !

!GTExampleTextSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 11:56'!
gtDisplayOn: aStream
	self text gtDisplayOn: aStream! !

!GTExampleMethodAfter methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:54'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock
		value: #'Browse after-method "' ,  self method gtDisplayString , '"'
		value: [ self method browse ]! !

!GTExampleMethodAfter methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 17:47'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 102>
	aStep listProcessor
		title: 'Examples with after Method ', self gtDisplayString;
		filter: GTNullFilter item: [ :filter :context | 
			GTExampleOrganizer instance examplesDo: [ :cn :s :example |
				(example hasAfter: self) ifTrue: [ filter value: example ] ] ];
		wantsToDisplayOnEmptyQuery: true! !

!GTExampleClassSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 16:54'!
addToSelectorEnvironment: aSelectorEnvironment
	self exists ifFalse: [ ^ self ].
	
	aSelectorEnvironment addClass: self theClass! !

!GTExampleClassSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:52'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock 
		value: #'Browse class-subject "' ,  self theClassName , '"'
		value: [ self theClass browse ]
! !

!GTExampleClassSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:15'!
gtDisplayOn: aStream
	self theClassName gtDisplayOn: aStream.
	self gtDisplayValidityOn: aStream! !

!GTExampleMethodIcon methodsFor: '*GT-Examples-UI' stamp: ''!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 0>
	self exists ifFalse: [ ^ self ].
	
	self form gtInspectorFormIn: composite! !

!GTExampleResult methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:16'!
gtDisplayOn: aStream
	self example gtDisplayOn: aStream. 
	
	self unexpectedError ifNotNil: [ 
		aStream nextPutAll: ' ['.
		self unexpectedError gtDisplayOn: aStream.
		aStream nextPutAll: ']' ]! !

!GTExampleResult methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:17'!
gtDisplayValidityOn: aStream
	self isSuccess ifTrue: [ ^ self ].
	
	aStream nextPutAll: ' ['.
	self unexpectedError gtDisplayOn: aStream.
	aStream nextPutAll: ']'! !

!GTSpotter methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:58'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ Smalltalk gtExamplesContained ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: false! !

!RubAbstractTextArea methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 16:24'!
gtGetText
	^ self text asString! !

!CompiledMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:57'!
gtSpotterGTExampleSubjectsFor: aStep
	<spotterOrder: 101>
	aStep listProcessor
		title: 'Example Subject';
		items: [ { self asGTExampleSubject } ];
		itemName: [ :subject | subject gtDisplayString ];
		filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:53'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 12>
	aStep listProcessor
		title: 'Examples';
		items: [ self gtExamples ];
		filter: GTFilterSubstring! !

!TGTExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/19/2016 14:54'!
gtSpotterPreviewIn: aComposite
	<spotterPreview: 1>
	self exists ifFalse: [ ^ self ].
	
	aComposite pharoMethod
		title: [ self gtDisplayString ]; 
		display: [ :entity | entity method sourceCode ];
		smalltalkClass: [ self method methodClass ];
		entity: self! !

AbstractMethodIconAction subclass: #GTAbstractExampleNautilusActionButton
	instanceVariableNames: ''
	classVariableNames: 'CurrentAction'
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleNautilusActionButton class methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 23:32'!
currentAction
	^ CurrentAction ifNil: [ CurrentAction := GTExampleNautilusActionButton ]! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 23:32'!
currentAction: anObject
	MethodWidget methodsIconsCache removeAll.
	CurrentAction := anObject! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:04'!
iconForMethod: aCompiledMethod result: aResult
	aResult
		ifNil: [ ^ Smalltalk ui icons iconNamed: #testNotRunIcon ].
	aResult isSuccess
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testGreenIcon ].
	aResult isFailure
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testYellowIcon ].
	aResult isError
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testRedIcon ].
	^ Smalltalk ui icons iconNamed: #testNotRunIcon! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2016 22:49'!
isAbstract
	^ self == GTAbstractExampleNautilusActionButton ! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2016 23:32'!
isEnabled
	^ self currentAction == self! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:35'!
methodUpdated: aCompiledMethod with: aResult
	self currentAction ifNil: [ ^ self ].
	
	[ self currentAction methodUpdated: aCompiledMethod with: aResult ]
		on: Error
		do: [ " ignore " ].
	
	[ NautilusUI allSubInstances do: #updateCategoryAndMethodList ]
		on: Error 
		do: [ " ignore " ]! !

!GTAbstractExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 22:51'!
actionOrder
	"Return the priority of this action"
	
	^ 0! !

!GTAbstractExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 23:33'!
isActionHandled
	^ self class isAbstract not 
		and: [ self class isEnabled
			and: [ method isGTExampleMethod ] ]! !

GTAbstractExampleNautilusActionButton subclass: #GTExampleNautilusActionButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:07'!
methodUpdated: aCompiledMethod with: aResult
	MethodWidget methodsIconsCache 
		at: aCompiledMethod 
		ifPresent: [ :holder | 
			holder labelGraphic: (self iconForMethod: aCompiledMethod result: aResult) ]! !

!GTExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 23:10'!
privateActionIcon
	"Return the icon for this action"
	^ IconicButton new
		target: self;
		actionSelector: #run:;
		arguments: { method };
		labelGraphic: (self class iconForMethod: method result: nil);
		color: Color transparent;
		helpText: 'Run';
		extent: 16 @ 16;
		borderWidth: 0! !

!GTExampleNautilusActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:14'!
run: aCompiledMethod
	aCompiledMethod gtExample ifNotNil: [ :example | 
		example result ifNotNil: [ :result |
			result isSuccess 
				ifTrue: [ result returnValue inspect ]
				ifFalse: [ example debug ] ] ]! !

GTAbstractExampleNautilusActionButton subclass: #GTExampleNautilusDualActionButton
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusDualActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:07'!
methodUpdated: aCompiledMethod with: aResult
	MethodWidget methodsIconsCache 
		at: aCompiledMethod 
		ifPresent: [ :array | 
			array second labelGraphic: (self iconForMethod: aCompiledMethod result: aResult) ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:16'!
actionInspectExample
	^ IconicButton new
		target: self;
		actionSelector: #inspectExample:;
		arguments: { method };
		color: Color transparent;
		helpText: 'Inspect Example';
		extent: 16 @ 8;
		borderWidth: 0! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:15'!
actionInspectReturnValue
	^ IconicButton new
		target: self;
		actionSelector: #inspectReturnValue:;
		arguments: { method };
		color: Color transparent;
		helpText: 'Inspect Return-Value';
		extent: 16 @ 8;
		borderWidth: 0! !

!GTExampleNautilusDualActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 22:54'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	^ result 
		ifNil: [ super actionStateToCache ]
		ifNotNil: [ self exampleStateToCache ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:58'!
actions
	| action1 action2 |
	^ result := ((Morph new
		extent: 16@16;
		color: Color transparent;
		borderWidth: 0;
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: (action1 := self actionInspectExample);
		addMorph: (action2 := self actionInspectReturnValue);
		yourself) -> { action1. action2 })! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:54'!
exampleStateToCache
	^ {
		IconicButtonStateHolder forNautilus: result value first. 
		IconicButtonStateHolder forNautilus: result value second } ! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:03'!
inspectExample: aCompiledMethod
	aCompiledMethod gtExample 
		ifNotNil: [ :example | example inspect ]
		ifNil: [ self notifyNoExample: aCompiledMethod ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:01'!
inspectReturnValue: aCompiledMethod
	aCompiledMethod gtExample 
		ifNotNil: [ :example | 
			example result 
				ifNotNil: [ :exampleResult |
					exampleResult isSuccess 
						ifTrue: [ result returnValue inspect ]
						ifFalse: [ example debug ] ] ]
		ifNil: [ self notifyNoExample: aCompiledMethod ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:02'!
notifyNoExample: aCompiledMethod
	GrowlMorph 
		openWithLabel: 'No valid example in'
		contents: aCompiledMethod gtDisplayString! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:58'!
privateActionIcon
	^ self actions key! !

!GTExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:55'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock
		value: #'Browse dependency-method "' ,  self method gtDisplayString, '"'
		value: [ self method browse ]! !

!GTExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/22/2016 11:41'!
gtDisplayValidityOn: aStream
	self isValid ifTrue: [ ^ self ].
	
	self exists ifFalse: [ ^ aStream nextPutAll: ' [does not exist]' ].
	self hasValidArguments ifFalse: [ ^ aStream nextPutAll: '[invalid arguments]' ].
	aStream nextPutAll: ' [invalid]'! !

!RBSelectorEnvironment methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 00:08'!
gtBrowseFor: aString
	| browser |
	metaClassSelectors keysAndValuesDo: [ :class :selectors | 
		classSelectors at: class ifAbsentPut: [ IdentitySet new ] ].
	browser := self browse.
	browser ui 
		title: aString; 
		packageSearchUpdate: ''.
	^ browser! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 15:52'!
gtDebuggerSourceIn: composite
	<gtDebuggerPresentationOrder: 1>
	self exists ifFalse: [ ^ self ].
	^ (self method gtInspectorSourceIn: composite)
		title: 'Method'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:19'!
gtDisplayOn: aStream
	self label isEmptyOrNil 
		ifTrue: [ 
			aStream 
				print: self methodClass; 
				nextPutAll: ' >> '; 
				print: self selector ]
		ifFalse: [ 
			aStream nextPutAll: self label ].
		
	self gtDisplayValidityOn: aStream! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:17'!
gtDisplayValidityOn: aStream
	self isValid ifTrue: [ ^ self ].
	
	aStream nextPutAll: ' [invalid]'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/6/2016 13:30'!
gtInspectorActionReturnValue
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ :p | p selection: (self runThenDo: [ :r | r returnValue ] onErrorDo: [ :r | r ]) ];
		icon: (Smalltalk ui icons iconNamed: #glamorousGo);
		title: 'Evaluate and inspect return-value'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/13/2016 09:58'!
gtInspectorActionSubjects
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ GTExampleNavigation browseAllExampleSubjects: { self } ];
		icon: (Smalltalk ui icons iconNamed: #glamorousBookmark);
		title: 'Subjects'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/21/2016 17:12'!
gtInspectorActions
	^ super gtInspectorActions 
		addAll: self gtInspectorCustomActions;
		yourself! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:34'!
gtInspectorAfterIn: composite
	<gtInspectorPresentationOrder: 3>
	self hasAfter ifFalse: [ ^ self ].
	^ ({ self after } gtInspectorItemsIn: composite)
			title: 'After'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/21/2016 17:39'!
gtInspectorCustomActions
	self hasExtensions ifFalse: [ ^ { } ].
	
	^ Array streamContents: [ :stream | 
		extensions do: [ :each | 
			(each gtInspectorActionFor: self) ifNotNil: [ :action |
				stream nextPut: action ] ] ] ! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/21/2016 14:51'!
gtInspectorCustomExtensionsFor: composite
	<gtInspectorPresentationOrder: 99>
	self hasExtensions ifFalse: [ ^ self ].
	
	extensions do: [ :extension |
		extension gtInspectorFor: composite example: self ]! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:33'!
gtInspectorDependenciesIn: composite
	<gtInspectorPresentationOrder: 1>
	self hasDependencies ifFalse: [ ^ self ].
	^ (self dependenciesOrArguments gtInspectorItemsIn: composite)
			title: 'Dependencies'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:33'!
gtInspectorDependentsIn: composite
	<gtInspectorPresentationOrder: 2>
	self hasDependents ifFalse: [ ^ self ].
	^ (self directDependents gtInspectorItemsIn: composite)
			title: 'Dependents'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 15:52'!
gtInspectorMethodIn: composite
	<gtInspectorPresentationOrder: 0>
	self exists ifFalse: [ ^ self ].
	^ (self method gtInspectorSourceIn: composite)
		title: 'Method'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:35'!
gtInspectorProblemsIn: composite
	<gtInspectorPresentationOrder: 5>
	self hasProblems ifFalse: [ ^ self ].
	^ (self problems gtInspectorItemsIn: composite)
			title: 'Problems'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/14/2016 12:24'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 0>
	^ (self method gtInspectorSourceIn: composite)
		title: 'Source'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:36'!
gtInspectorSubjectsIn: composite
	<gtInspectorPresentationOrder: 4>
	self hasSubjects ifFalse: [ ^ self ].
	^ (self subjects gtInspectorItemsIn: composite)
			title: 'Subjects'! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterAfterFor: aStep
	<spotterOrder: 3>
	self hasAfter ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Example After';
		items: [ { self after } ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/21/2016 14:40'!
gtSpotterCustomExtensionsFor: aStep
	<spotterOrder: 99>
	self hasExtensions ifFalse: [ ^ self ].
	
	extensions do: [ :extension |
		extension gtSpotterFor: aStep example: self ]! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterDependenciesFor: aStep
	<spotterOrder: 1>
	self hasDependencies ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Example Dependencies';
		items: [ self dependenciesOrArguments ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterDependentsFor: aStep
	<spotterOrder: 2>
	self hasDependents ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Example Dependents';
		items: [ self directDependents ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterGTExampleSubjectsFor: aStep
	<spotterOrder: 4>
	self hasSubjects ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Example Subjects';
		items: [ self subjects asArray ];
		itemName: [ :subject | subject gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterMethodFor: aStep
	<spotterOrder: 0>
	self exists ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Method';
		items: [ Array with: self method ];
		itemName: [ :aSource | aSource gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 18:32'!
gtSpotterProblemsFor: aStep
	<spotterOrder: 5>
	self hasProblems ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'Example Problems';
		items: [ self problems ];
		itemName: [ :problem | problem gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
inspector: aSelector
	<gtExamplePragma>
	<description: 'A method providing a custom GTInspector-extensions for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodInspectorExtension example: self selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
inspectorAction: aSelector
	<gtExamplePragma>
	<description: 'A method providing a custom GTInspector-action for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodInspectorActionExtension example: self selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
inspectorActionClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by (aClassOrClassName >> aSelector), providing a custom GTInspector-actions for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodInspectorActionExtension example: self className: aClassOrClassName meta: false selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
inspectorClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by (aClassOrClassName >> aSelector), providing custom GTInspector-extensions for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodInspectorExtension example: self className: aClassOrClassName meta: false selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
spotter: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by aSelector, providing a custom GTSpotter-extension for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodSpotterExtension example: self selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI-PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
spotterClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by (aClassOrClassName >> aSelector), providing a custom GTSpotter-extension for this particular example'>
	
	self addExtension: (self methodResolverClass resolve: GTExampleMethodSpotterExtension example: self className: aClassOrClassName meta: false selector: aSelector)! !

!GTExample methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 9/9/2015 20:10'!
spotterPreviewIn: aComposite inContext: aSpotter
	^ self gtSpotterPreviewIn: aComposite! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:19'!
gtInspectorGTExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Examples';
		display: [ self gtExamples ];
		icon: [:each | each icon];
		format: [ :each | each gtDisplayString ] ;
		send: [ :each | each returnValue ];
		when: [ self gtExamples notEmpty ]! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:57'!
gtSpotterGTExampleSubjectsFor: aStep
	<spotterOrder: 101>
	aStep listProcessor
		title: 'Example Subject';
		items: [ { self asGTExampleSubject } ];
		itemName: [ :subject | subject gtDisplayString ];
		filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:53'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		items: [ self gtExamples ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleSubclassesSubject methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/22/2016 12:32'!
addToSelectorEnvironment: aSelectorEnvironment
	self exists ifFalse: [ ^ self ].
	
	super addToSelectorEnvironment: aSelectorEnvironment.
	self theSubclasses do: [ :class | 
		class asGTExampleSubject addToSelectorEnvironment: aSelectorEnvironment ]! !

!GTExampleAspect methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 15:44'!
addToSelectorEnvironment: aSelectorEnvironment! !

!GTExampleAspect methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 15:44'!
forNautilus: aBlock
	! !

!GTExampleAspect methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/22/2016 11:41'!
gtDisplayValidityOn: aStream
	self isValid ifTrue: [ ^ self ].
	
	self exists ifFalse: [ ^ aStream nextPutAll: ' [does not exist]' ].
	aStream nextPutAll: ' [invalid]'! !

!Class methodsFor: '*GT-Examples-UI' stamp: 'PavelKrivanek 4/20/2017 11:05'!
gtInspectorGTExamplesIn: composite
	<gtInspectorPresentationOrder: 40>

	<localClassMethod> 
   "This method is supposed to be local in Class because of a good reason.
   We use this pragma to test if Class does not contain some accidental 
   local selectors."

	composite list 
		title: 'Examples';
		display: [ self gtExamples ];
		icon: [:each | each icon];
		format: [:each | each gtDisplayString ];
		in: [ :list | list sorted: [ :a :b | (list format cull: a) < (list format cull: b)] ];
		send: [ :each | each returnValue ];
		when: [ self gtExamples notEmpty ]! !

!GTAbstractExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/11/2016 15:58'!
addToSelectorEnvironment: aSelectorEnvironment
	self exists ifFalse: [ ^ self ].
	
	aSelectorEnvironment addClass: self methodClass selector: self selector! !

!GTAbstractExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/28/2016 14:55'!
forNautilus: aBlock
	self exists ifFalse: [ ^ self ].
	
	aBlock
		value: #'Browse method "' ,  self method gtDisplayString , '"'
		value: [ self method browse ]! !

!GTAbstractExampleMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:11'!
gtDisplayOn: aStream
	aStream 
		nextPutAll: self methodClassName asString; 
		nextPutAll: ' >> #'; 
		nextPutAll: self selector asString.
		
	self gtDisplayValidityOn: aStream! !

!GTAbstractExampleMethod methodsFor: '*GT-Examples-UI' stamp: ''!
gtSpotterPreviewIn: aComposite
	<spotterPreview: 1>
	self exists ifFalse: [ ^ self ].
	
	aComposite pharoMethod
		title: [ self gtDisplayString ]; 
		display: [ :entity | entity method sourceCode ];
		smalltalkClass: [ self method methodClass ];
		entity: self! !

GTAbstractExampleMethod subclass: #GTAbstractExampleMethodExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleMethodExtension class methodsFor: 'testing' stamp: 'StefanReichhart 7/21/2016 14:47'!
isAbstract
	^ self == GTAbstractExampleMethodExtension! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 17:13'!
gtInspectorActionFor: aGTExample
	^ nil! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:51'!
gtInspectorFor: composite example: aGTExample! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:36'!
gtSpotterFor: aStep example: aGTExample! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodInspectorActionExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodInspectorActionExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 17:13'!
gtInspectorActionFor: aGTExample
	^ self provider perform: self selector withArguments: { aGTExample }! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodInspectorExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodInspectorExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 15:39'!
gtInspectorFor: aComposite example: aGTExample
	self provider perform: self selector withArguments: { aComposite. aGTExample }! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodSpotterExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodSpotterExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:58'!
gtSpotterFor: aStep example: aGTExample
	self provider perform: self selector withArguments: { aStep. aGTExample }! !
